Curve Fitting Overview

Data Curve Fit Creator Add-in

Data Curve Fit Creator Add-in is an add-in for Microsoft Excel that adds curve fitting and other data analysis functions to Excel. The add-in is fully functional for a 30 day free trial period, and then after that it needs to be registered.

Data Curve Fit Creator Add-in is produced by SRS1 Software, LLC. Visit us at https://www.srs1software.com.


System Requirements

Data Curve Fit Creator Add-in requires the following:

  • Microsoft Windows - Windows 10, Windows 8.1, Windows 8, Windows 7, Vista, XP, Server 2016, Server 2012, or Server 2008 R2
  • Microsoft Excel - Supported versions include 2016(32 bit and 64 bit versions), 2013(32 bit and 64 bit versions), 2010(32 bit and 64 bit versions), 2007

Data Curve Fit Creator Add-in is produced by SRS1 Software, LLC.


Basic Usage

Data Curve Fit Creator Add-in Basic Usage

What does Data Curve Fit Creator Add-in do?

Data Curve Fit Creator Add-in adds a series of curve fitting and data analysis functions to Microsoft Excel. The new functions are accessed and used in the same way that the built in functions of Excel are accessed and used.

How do I install Data Curve Fit Creator Add-in?

To install Data Curve Fit Creator Add-in, simply double click on the "setup_dcfca.exe" install file. During the installation process, a "Data Curve Fit Creator Add-in" folder is created in your computer's Program Files folder (or custom location if you want). The "Data_Curve_Fit_Creator_Add-in.xlam" add-in file and several support files and copied into that folder. Next, the installer by default enables the add-in in Excel using the 'ManageDCFCAddin.exe' utility (see below).

How do I enable/disable Data Curve Fit Creator Add-in in Excel?

"Enabling" an add-in in Microsoft Excel means that you are telling Excel that you want the add-in to be automatically loaded when you open Excel. Excel keeps a list of current add-ins, keeps track of which ones are enabled and which ones are disabled (represented by a checkbox next to each add-in name in the Excel Add-ins dialog). The Data Curve Fit Creator Add-in install includes a small program named "ManageDCFCAddin.exe" which lets you automatically enable or disable the add-in in Excel. This is located in the Data Cureve Fit Creator Add-in install folder (located by default at 'C:\Program Files (x86)\Data Curve Fit Creator Add-in'). Double click on the 'ManageDCFCAddin.exe' or run it from a command line to get started. Note that this utility enables/disables the add-in by making changes to the system registry. Another way to enable or disable the add-in is via the standard Excel Add-ins dialog.

Where can I find the new Data Curve Fit Creator Functions in Excel?

There are a few ways to access the new functions in Excel. If you know the name of the function that you are going to use, then you can just type it into an Excel cell, just as you would for any other function in Excel. For example, you could type "=LinearInterp(" into a cell, and click the "f(x)" key on the formula bar, and then Excel will prompt you for the input values to the LinearInterp function.

Alternatively, you can select the small "Insert Function" button on the Excel formula bar to open Excel's 'Insert Function' dialog which displays a list of all available functions in Excel. The new functions will be listed under both the "All" and "DataCurveFitCreator" function groups. (Note that older versions of Data Curve Fit Creator Add-in listed functions under the "User Defined" category.)

How do I know if Data Curve Fit Creator Add-in is installed and configured correctly?

The quickest and easiest way to tell if Data Curve Fit Creator Add-in is installed and enabled is to open Excel and check for a new "Data Cureve Fit Creator" tab on the Excel ribbon bar. If you see the new ribbon tab, then the Data Curve Fit Creator Add-in is enabled and the new functions should be available to use. If you don't, then you should try to enable the Data Cureve Fit Creator Add-in in Excel (see above).

What is the quickest way to learn how to use the Data Curve Fit Creator functions?

Opening the "How to use DCFC_Add-in.xlsm" example Excel workbok, reading the function descriptions and experimenting with the functions is an excellent way to start. You can open the example workbook by clicking the 'Demo Workbook' button on the 'SRS1 Data Cureve Fit Creator' ribbon tab in Excel. You can also manually open the file from the 'Data Curve Fit Creator Add-in' install directory (located by default at 'C:\Program Files (x86)\Data Curve Fit Creator Add-in').

Another way that you can learn about Data Curve Fit Creator Add-in is by viewing our online demonstration videos.

What does the Repair/Refresh functions Ribbon button do?

This will refresh all Data Curve Fit Creator Add-in functions that you are using in the active workbook. If you open a workbook that has Data Curve Fit Creator Add-in functions in it, and in place of the function results you see errors (e.g. "#Name!") then try clicking this ribbon button to repair the functions.

This should also be used if you see full paths in place of simple function names in cells (e.g. instead of seeing "=MovingAvg(...)" you see "='C:\Program Files (x86)\....\Data_Curve_Fit_Creator_Add-in.xlam'!MovingAvg(...)". Full paths indicate that the workbook can't find the location of the add-in. Running the Repair/Refresh will resolve this.


Basic Usage

Data Curve Fit Creator Ribbon Menu

A custom tab is added to Excel's ribbon menu when the Data Curve Fit Creator Add-in is loaded in Excel. The new tab is labeled "Data Curve Fit Creator Add-in" and contains various functionality to support the use of the add-in. The custom tab is divided into the following sections:

Contact

  • Homepage - This button will open the Data Curve Fit Creator Add-in homepage on the SRS1 Software, LLC website. The homepage contains all the latest information about the add-in.
  • Give Instant Feedback - Click this button to send instant feedback (questions, problems, suggestions for future features, etc.) to us. We welcome your feedback!
  • Registration - Click this button to enter your registration number after purchasing Data Curve Fit Creator Add-in. When you purchase Data Curve Fit Creator, you are immediately given this number. Entering it here transforms your install from being a trial to being a paid version. After a valid registration number is entered, then you will no longer see the splash screen when Data Curve Fit Creator Add-in loads in Excel.
  • Buy Now! - This is a link to purchase Data Curve Fit Creator Add-in online.

Tools

  • Refresh/Repair Workbook - Clicking this button resolves common problems with Data Cureve Fit Creator Add-in. It will refresh all Data Curve Fit Creator Add-in functions on the current workbook. You would need to do this if you are seeing errors in place of results where you have entered Data Curve Fit Creator functions. This can happen if you open a workbook on a machine that has Data Curve Fit Creator installed in a different location.

Help

  • Help - This will open the Data Curve Fit Creator help file (this document). This help file is named 'dcfc_Help.chm' and is installed in the main Data Curve Fit Creator application folder during installation.
  • Demo Videos - Click this button to go to the demo video section of the Data Curve Fit Creator product home page on the web. There you can watch multiple videos demonstrating how to use Data Curve Fit Creator Add-in and Excel. It is an excellent resource for learning how to use this product.
  • Demo Workbook - Click this button to open a demonstration workbook that is delivered with Data Curve Fit Creator Add-in. The demonstration workbook describes how each custom function works, along with working examples of each. It is another excellent resource for you to learn how to use Data Curve Fit Creator. The demo workbook is named 'How to use DCFC_Add-in.xlsm' and is installed in the main Data Curve Fit Creator application folder.
  • Check for Updates - Clicking this button will check if there is a newer version of Data Curve Fit Creator Add-in available. If there is, then the resulting dialog will provide a link for where it can be downloaded.
  • About - Click this button to display information about your install of Data Curve Fit Creator Add-in, including product version, registration information, etc.


Security Settings

All Data Curve Fit Creator Add-in files are digitally signed to ensure that they are from SRS1 Software, LLC and haven't been modified.

The first time that you try to install and/or run Data Curve Fit Creator Add-in, you might be prompted about whether you want to "Enable Macros", "Disable Macros" for that workbook, or "Trust all documents from this publisher (SRS1 Software, LLC)". You should select the option to "Trust all documents from this publisher (SRS1 Software, LLC)". This will add SRS1 Software, LLC to Excel's internal list of trusted sources. When Excel sees a document that is signed by SRS1 Software, LLC then it will allow it to run. If you don't do this, then you might run into problems with Data Curve Fit Creator Add-in being blocked by Excel.


Returning Multiple Values From Functions

For several of the functions in Data Curve Fit Creator Add-in, it is critical that you know a simple little trick for how to receive "array" results from formulas in Excel. It is pretty simple, but there is a simple trick, described here, that you must know in order to get it to work. This is all described in the Excel help documentation as well.

Most functions in Excel return a single value. For example, if you are adding two numbers in Excel, you'd type something like "=2+2" in a cell and the result would be the number "4". You then see the "4" in the cell where you typed in the formula.

Some functions, though, return multiple values. This requires your results to go into more than one cell. There are many Excel functions like this (for example, all the matrix math Excel functions). Some of the Data Curve Fit Creator Add-in functions also return multiple values.

For example, consider the MovingAvg() function. The number of values that is outputted by the function equals the number of values in the dataset that you are performing a moving average on. If you are applying a moving average on a column of 10 numbers, then your output will be a column of 10 numbers also. If you just type the function into a cell and press enter, then you'll only get one number back. To get the full array of values back, you need to do the following:

  1. Highlight the cells where you want your results to go (e.g. if you expect to get a column of 10 values back from your formula, then highlight a column of 10 cells)
  2. Type the formula in, just as you normally do (note, you still should have the 10 cells selected). Do NOT press the ENTER key or click on the checkmark on the formula bar yet... (see step 3)
  3. After typing in the formula, instead of pressing the ENTER key on your keyboard, you must FIRST HOLD DOWN THE CONTROL and SHIFT KEYS, THEN WHILE STILL HOLDING THEM DOWN, CLICK THE ENTER KEY. This tells Excel that you are receiving an array of values back, and Excel will place those multiple values into the cells that you have highlighted.

Note - You can see the Excel help documentation for more of a description of how to return an array back from a formula.

You can also see a video demonstration of how to do this on our website at: https://www.srs1software.com/DataCurveFitCreator.aspx


Given a set of data points (input values and output values) curve fitting is a process for finding that provides an estimated output value for any input value. There are two general types of curve fits. We'll call them "exact" fits, and "estimation" fits.

Exact Fits

The first is an exact fit to data. This includes linear interpolations and spline interpolation. The other family of curve fits are estimation fits. This set of fits includes methods such as polynomial fitting, local (lowess) regressions and non-linear curve fits.

Some types of curve fitting include:

  • Linear Interpolation - This is the most basic type of curve fitting. This is a "connect-the-dots" method for which the data points are ordered and then a straight line is drawn from point to point.
  • Cubic Spline - This is similar to linear interpolation, except a smooth curved line is drawn between all the data points in a dataset. One potential problem with the Cubic Spline is that it is not as predictable as the Linear Interpolation. If there is a lot of noise in your data, then the resulting Cubic Spline curve might behave unexpectedly in order to force the curve to pass through each data point. [Note - For more information about cubic spline curve through a set of data points, Data Curve Fit Creator Add-in includes a function named CubicSplineExtraVals which returns the curve slope and curve formula coefficients at any point.]
  • Bessel Spline - This is similar to the cubic spline, except it uses a different method for calculating the shape of the curve. Whereas the cubic spline fits a third order polynomial fit to the local region, the Bessel spline uses a parabolic function fit to the local data points to the derive its shape. In some cases the Bessel fit can create a curve with fewer unwanted oscillations than the cubic spline.
  • One Way (monotonic) Spline - This is similar to the Bessel Spline, with some additional overrides incorporated into it that produce a monotonic result when the source data is monotonic. 'Monotonic' data means that the data is only increasing or only decreasing (slope is either always non-negative or non-positive). This spline can still be used with non-monotonic data. In that case, the resulting spline will also not be monotonic. Compared with the other spline functions offered, this type of spline produces the tightest (fewest unwanted oscillations) fit.
  • Flex Spline - The flex spline also draws a curved line between the points of a data set, but Flex Spline gives you a lot more control over the shape of the curved line than the Cubic Spline curve. With the Flex Spline, you can specify the slope of the curve at any of the data points.

Estimation Fits

Estimation curve fits do NOT necessarily pass exactly through each data point in your data set. Some types of estimation curve fitting includes:

  • Polynomial Fit - This fits a polynomial curve to the provided data set. You can adjust the order of the fit and the weighting of each data point. For example, if it is very important for your curve to pass through a particular point, then weighting that point higher than others can encourage this. Another benefit of the Polynomial Fit in general is that it produces an equation of the Polynomial curve that is fit to your data. The PolyCoef() function can be used to retrieve the coefficients from that equation.
  • RegionFit (A.K.A. Lowess Fit) - This is a very flexible algorithm that performs a polynomial fit to a dataset, but only uses a subset of data that is closest to the point being estimated. For each point that you are getting an estimate for, a separate polynomial fit is done, each time the data points are weighted to only include the points closest to the point being estimated. You can adjust many parameters in the Region Fit algorithm, such as the polynomial order and size of the region used in each fit.

For more information about these fits, see the descriptions in their sections of the help file.


Data Smoothing Overview

Data Curve Fit Creator includes several functions for smoothing data:

  • Moving Average - This is is the simplest method for data smoothing. It replaces each data point with an average of the surrounding points. By changing the windows size, you control how much smoothing is applied.
  • Median Filter - This is best for filtering out spikey noise in a data set. For example if your data contains an off value, the median filter can totally remove the effect of the point from the data set. Conversely, a Moving Average filter would smooth over the bad data point, but it still would effect the surrounding data points.
  • Gaussian Smooth - This is similar to the Moving Average, but is more sophisticated and can oftentime produce better results. In its averaging, it assigns higher weights to points closer to the middle of the smoothing window compared with those on the far edge of the smoothing window. The distribution of the weight values in the smoothing window follows a Gaussian Distribution shape. Theoretically, a Gaussian Filter should be able to remove normally distributed noise in your data best.

    • For more information about these data smoothing functions, see the descriptions in their sections of the help file.


Data Helper Functions Overview

Data Curve Fit Creator includes some additional functions that are useful for managing data:

  • DataGapsRemove - This function removed blank (and optionally non-numeric) data from a dataset. You provide a column, row, or table of data, and the function returns the dataset with all blank entries removed. This could be useful, for example, if you are importing a set of measurement data into a spreadsheet, and the data contains some missed readings. This would also be useful for removing invalid entries from a table of data.
  • DataGapsLinearFill - This is similar to the 'DataGapsRemove' function, except here the 'bad' data points are filled with estimated values. The estimates are calculated by linearly interpolating from the nearest known data points. Any estimates at the end points of the datasets are either extrapolated from the known data or just set to the nearest known data value.
  • SortData - This function continuously sorts a column, row, or table of data. You can use it to keep a maintain a continuously sorted version of a dataset in your workbook. Data can be sorted in ascending or descending order, and a secondary sort column/row can be specified. Also, blank cells and optionally be removed from the sort.

    • For more information about these functions, see the descriptions in their sections of the help file.


Product Registration

Data Curve Fit Creator Add-in is fully functional for a 30 day free trial period. After that, you can purchase Data Curve Fit Creator Add-in by going to our website, or by clicking on this direct link:

https://www.srs1software.com/dcfca_reg.htm

As soon as you make your purchase, you will be given a registration number. You enter that number into the software by clicking the "Registration" button on the Data Curve Fit Creator Add-in tab of the Excel ribbon menu. You will then be prompted for the registration number, and then your registration is complete. You can also enter your registration number by clicking the "Registration" button on the Data Curve Fit Creator Add-in "About" dialog.

Minor upgrades of Data Curve Fit Creator Add-in are always FREE (see https://www.srs1software.com).


End User License Agreement

LICENSE

SRS1 Software, LLC (SRS1) hereby gives you a non-exclusive license to use the software "Data Curve Fit Creator Add-in" (the Software). For evaluation of the software, the license is granted, and is time-limited. Purchased licenses for the software are perpetual. Purchasing a license entitles you to use the purchased version of the software for an unlimited amount of time.

You may:

- install the software onto one separate computer for each of the licenses purchased. For example, if you buy three licenses, then the software can be installed and used on three separate computers simultaneously within an organization.

- copy the Software for archival purposes, provided any copy contains all of the original Software's proprietary notices.

You may not:

- modify, translate, reverse engineer, decompile, disassemble (except to the extent applicable laws specifically prohibit such restriction),

- create derivative works based on the Software;

- copy the Software (except as specified above);

- rent, lease, transfer or otherwise transfer rights to the Software;

- remove any proprietary notices or labels on the Software.

- attempt to access or re-use the add-in source code

- attempt to use the software beyond the designated trial time period

TERMINATION

The license will terminate automatically if you fail to comply with the limitations described above. On termination, you must destroy all copies of the Software and Documentation.

GOVERNING LAW

This PRODUCT EULA will be governed by and construed in accordance with the laws of the Commonwealth of Massachusetts and of the United States of America.

DISCLAIMER OF WARRANTY

The Software is provided on an AS IS basis, without warranty of any kind, including without limitation the warranties of merchantability, fitness for a particular purpose and non-infringement. The entire risk as to the quality and performance of the Software is borne by you. Should the Software prove defective, you and not SRS1 Software, LLC assume the entire cost of any service and repair.

SRS1 Software, LLC IS NOT RESPONSIBLE FOR ANY INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES OF ANY CHARACTER INCLUDING, WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL OTHER COMMERCIAL DAMAGES OR LOSSES.

Title, ownership rights and intellectual property rights in and to the Software shall remain in SRS1 Software, LLC. The Software is protected by international copyright treaties.


Contact Us

Data Curve Fit Creator Add-in is produced by SRS1 Software, LLC. Visit our website for product updates, information, etc. Minor product upgrades are always free.

Website:

https://www.srs1software.com

Email:

feedback@srs1software.com

Instant feedback:

Click the 'Give Instant Feedback' button on the Data Curve Fit Creator tab of Excel's ribbon menu.

We welcome your feedback and comments!